Rem =======================================================================
Rem Run this only if Oracle Spatial Data Option is installed:
Rem =======================================================================

-- Run this while connected as SYSDBA 
ALTER SESSION SET CURRENT_SCHEMA = MDSYS;

CREATE OR REPLACE TRIGGER MDSYS.SDO_GEOM_TRIG_INS1
INSTEAD OF INSERT ON MDSYS.user_sdo_geom_metadata
REFERENCING NEW AS n
FOR EACH ROW
declare
 tname varchar2(32);
 stmt  varchar2(500);
 vcount INTEGER;
BEGIN
                                                                                
  EXECUTE IMMEDIATE
  'SELECT user FROM dual' into tname;
                                                                                
  if ( (instr(:n.table_name, ' ') > 0 ) OR
       (instr(:n.table_name, '''') > 0 ) )  then
   mderr.raise_md_error('MD', 'SDO', -13223,
               :n.table_name||'.'||:n.column_name);
   end if;
  if ( (instr(:n.column_name, ' ') > 0 ) OR
       (instr(:n.column_name, '''') > 0 ) ) then
   mderr.raise_md_error('MD', 'SDO', -13223,
               :n.table_name||'.'||:n.column_name);
   end if;
                                                                                
  stmt :=  'SELECT count(*) FROM MDSYS.SDO_GEOM_METADATA_TABLE ' ||
  'WHERE sdo_owner = :tname  AND sdo_table_name = :table_name  '||
  '  AND  sdo_column_name = :column_name  ';
--  '  AND SDO_SRID = '||:n.srid ;
EXECUTE IMMEDIATE stmt INTO vcount
   USING tname, :n.table_name, :n.column_name;
  IF vcount = 0 THEN
    INSERT INTO MDSYS.sdo_geom_metadata_table values
             (upper(tname),
             upper(:n.table_name), upper(:n.column_name), :n.diminfo,
             :n.srid);
  ELSE
   mderr.raise_md_error('MD', 'SDO', -13223,
               :n.table_name||'.'||:n.column_name);
 END IF;
END;
/
show errors;


ALTER SESSION SET CURRENT_SCHEMA = SYS;


